#include <stdio.h>
# define U(x) x
# define NLSTATE yyprevious=YYNEWLINE
# define BEGIN yybgin = yysvec + 1 +
# define INITIAL 0
# define YYLERR yysvec
# define YYSTATE (yyestate-yysvec-1)
# define YYOPTIM 1
# define YYLMAX BUFSIZ
#ifndef __cplusplus
# define output(c) (void)putc(c,yyout)
#else
# define lex_output(c) (void)putc(c,yyout)
#endif

#if defined(__cplusplus) || defined(__STDC__)

#if defined(__cplusplus) && defined(__EXTERN_C__)
extern "C" {
#endif
	int yyback(int *, int);
	int yyinput(void);
	int yylook(void);
	void yyoutput(int);
	int yyracc(int);
	int yyreject(void);
	void yyunput(int);
	int yylex(void);
#ifdef YYLEX_E
	void yywoutput(wchar_t);
	wchar_t yywinput(void);
#endif
#ifndef yyless
	int yyless(int);
#endif
#ifndef yywrap
	int yywrap(void);
#endif
#ifdef LEXDEBUG
	void allprint(char);
	void sprint(char *);
#endif
#if defined(__cplusplus) && defined(__EXTERN_C__)
}
#endif

#ifdef __cplusplus
extern "C" {
#endif
	void exit(int);
#ifdef __cplusplus
}
#endif

#endif
# define unput(c) {yytchar= (c);if(yytchar=='\n')yylineno--;*yysptr++=yytchar;}
# define yymore() (yymorfg=1)
#ifndef __cplusplus
# define input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#else
# define lex_input() (((yytchar=yysptr>yysbuf?U(*--yysptr):getc(yyin))==10?(yylineno++,yytchar):yytchar)==EOF?0:yytchar)
#endif
#define ECHO fprintf(yyout, "%s",yytext)
# define REJECT { nstr = yyreject(); goto yyfussy;}
int yyleng;
char yytext[YYLMAX];
int yymorfg;
extern char *yysptr, yysbuf[];
int yytchar;
FILE *yyin = {stdin}, *yyout = {stdout};
extern int yylineno;
struct yysvf { 
	struct yywork *yystoff;
	struct yysvf *yyother;
	int *yystops;};
struct yysvf *yyestate;
extern struct yysvf yysvec[], *yybgin;

# line 3 "scanner.l"
/*
 * Copyright (c) 1988, 1989, 1990, 1991, 1992, 1993, 1994, 1995, 1996, 1997
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that: (1) source code distributions
 * retain the above copyright notice and this paragraph in its entirety, (2)
 * distributions including binary code include the above copyright notice and
 * this paragraph in its entirety in the documentation or other materials
 * provided with the distribution, and (3) all advertising materials mentioning
 * features or use of this software display the following acknowledgement:
 * ``This product includes software developed by the University of California,
 * Lawrence Berkeley Laboratory and its contributors.'' Neither the name of
 * the University nor the names of its contributors may be used to endorse
 * or promote products derived from this software without specific prior
 * written permission.
 * THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
 */

#ifndef lint
static const char rcsid[] =
    "@(#) $Header: scanner.l,v 1.56 97/07/21 13:31:50 leres Exp $ (LBL)";
#endif

#include <sys/types.h>
#include <sys/time.h>

#include <ctype.h>
#include <unistd.h>

#include "pcap-int.h"

#include "gencode.h"
#include <pcap-namedb.h>
#include "tokdefs.h"

#include "gnuc.h"
#ifdef HAVE_OS_PROTO_H
#include "os-proto.h"
#endif

static int stoi(char *);
static inline int xdtoi(int);

#ifdef FLEX_SCANNER
#define YY_NO_UNPUT
#undef YY_INPUT
#define YY_INPUT(buf, result, max)\
 {\
	char *src = in_buffer;\
	int i;\
\
	if (*src == 0)\
		result = YY_NULL;\
	else {\
		for (i = 0; *src && i < max; ++i)\
			buf[i] = *src++;\
		in_buffer += i;\
		result = i;\
	}\
 }
#else
#undef getc
#define getc(fp)  (*in_buffer == 0 ? EOF : *in_buffer++)
#endif

#define yylval pcap_lval
extern YYSTYPE yylval;

static char *in_buffer;

# define YYNEWLINE 10
yylex(){
int nstr; extern int yyprevious;
#ifdef __cplusplus
/* to avoid CC and lint complaining yyfussy not being used ...*/
static int __lex_hack = 0;
if (__lex_hack) goto yyfussy;
#endif
while((nstr = yylook()) >= 0)
yyfussy: switch(nstr){
case 0:
if(yywrap()) return(0); break;
case 1:

# line 83 "scanner.l"
	return DST;
break;
case 2:

# line 84 "scanner.l"
	return SRC;
break;
case 3:

# line 86 "scanner.l"
 return LINK;
break;
case 4:

# line 87 "scanner.l"
	return LINK;
break;
case 5:

# line 88 "scanner.l"
	return ARP;
break;
case 6:

# line 89 "scanner.l"
	return RARP;
break;
case 7:

# line 90 "scanner.l"
	return IP;
break;
case 8:

# line 91 "scanner.l"
	return TCP;
break;
case 9:

# line 92 "scanner.l"
	return UDP;
break;
case 10:

# line 93 "scanner.l"
	return ICMP;
break;
case 11:

# line 94 "scanner.l"
	return IGMP;
break;
case 12:

# line 95 "scanner.l"
	return IGRP;
break;
case 13:

# line 97 "scanner.l"
	return ATALK;
break;
case 14:

# line 98 "scanner.l"
	return DECNET;
break;
case 15:

# line 99 "scanner.l"
	return LAT;
break;
case 16:

# line 100 "scanner.l"
	return SCA;
break;
case 17:

# line 101 "scanner.l"
	return MOPRC;
break;
case 18:

# line 102 "scanner.l"
	return MOPDL;
break;
case 19:

# line 104 "scanner.l"
	return HOST;
break;
case 20:

# line 105 "scanner.l"
	return NET;
break;
case 21:

# line 106 "scanner.l"
	return MASK;
break;
case 22:

# line 107 "scanner.l"
	return PORT;
break;
case 23:

# line 108 "scanner.l"
	return PROTO;
break;
case 24:

# line 110 "scanner.l"
	return GATEWAY;
break;
case 25:

# line 112 "scanner.l"
	return LESS;
break;
case 26:

# line 113 "scanner.l"
	return GREATER;
break;
case 27:

# line 114 "scanner.l"
	return BYTE;
break;
case 28:

# line 115 "scanner.l"
return TK_BROADCAST;
break;
case 29:

# line 116 "scanner.l"
return TK_MULTICAST;
break;
case 30:

# line 118 "scanner.l"
return AND;
break;
case 31:

# line 119 "scanner.l"
	return OR;
break;
case 32:

# line 120 "scanner.l"
	return '!';
break;
case 33:

# line 122 "scanner.l"
return LEN;
break;
case 34:

# line 123 "scanner.l"
	return INBOUND;
break;
case 35:

# line 124 "scanner.l"
return OUTBOUND;
break;
case 36:

# line 126 "scanner.l"
		;
break;
case 37:

# line 127 "scanner.l"
return yytext[0];
break;
case 38:

# line 128 "scanner.l"
		return GEQ;
break;
case 39:

# line 129 "scanner.l"
		return LEQ;
break;
case 40:

# line 130 "scanner.l"
		return NEQ;
break;
case 41:

# line 131 "scanner.l"
		return '=';
break;
case 42:

# line 132 "scanner.l"
		return LSH;
break;
case 43:

# line 133 "scanner.l"
		return RSH;
break;
case 44:

# line 134 "scanner.l"
		{ yylval.i = stoi((char *)yytext); return NUM; }
break;
case 45:

# line 135 "scanner.l"
{
			yylval.s = sdup((char *)yytext); return HID; }
break;
case 46:

# line 137 "scanner.l"
{ yylval.e = pcap_ether_aton((char *)yytext);
			  return EID; }
break;
case 47:

# line 139 "scanner.l"
	{ bpf_error("bogus ethernet address %s", yytext); }
break;
case 48:

# line 140 "scanner.l"
{
			 yylval.s = sdup((char *)yytext); return ID; }
break;
case 49:

# line 142 "scanner.l"
{ yylval.s = sdup((char *)yytext + 1); return ID; }
break;
case 50:

# line 143 "scanner.l"
{
			bpf_error("illegal token: %s\n", yytext); }
break;
case 51:

# line 145 "scanner.l"
		{ bpf_error("illegal char '%c'", *yytext); }
break;
case -1:
break;
default:
(void)fprintf(yyout,"bad switch yylook %d",nstr);
} return(0); }
/* end of yylex */
void
lex_init(buf)
	char *buf;
{
	in_buffer = buf;
}

/*
 * Also define a yywrap.  Note that if we're using flex, it will
 * define a macro to map this identifier to pcap_wrap.
 */
int
yywrap()
{
	return 1;
}

/* Hex digit to integer. */
static inline int
xdtoi(c)
	register int c;
{
	if (isdigit(c))
		return c - '0';
	else if (islower(c))
		return c - 'a' + 10;
	else
		return c - 'A' + 10;
}

/*
 * Convert string to integer.  Just like atoi(), but checks for
 * preceding 0x or 0 and uses hex or octal instead of decimal.
 */
static int
stoi(s)
	char *s;
{
	int base = 10;
	int n = 0;

	if (*s == '0') {
		if (s[1] == 'x' || s[1] == 'X') {
			s += 2;
			base = 16;
		}
		else {
			base = 8;
			s += 1;
		}
	}
	while (*s)
		n = n * base + xdtoi(*s++);

	return n;
}

int yyvstop[] = {
0,

51,
0, 

36,
51,
0, 

36,
0, 

37,
51,
0, 

37,
51,
0, 

37,
51,
0, 

37,
51,
0, 

51,
0, 

44,
51,
0, 

44,
51,
0, 

37,
51,
0, 

37,
51,
0, 

37,
51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

51,
0, 

37,
51,
0, 

50,
0, 

40,
0, 

30,
0, 

48,
0, 

44,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

42,
0, 

39,
0, 

41,
0, 

38,
0, 

43,
0, 

49,
0, 

49,
0, 

49,
50,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

7,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

31,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

31,
0, 

45,
48,
0, 

45,
48,
0, 

44,
48,
0, 

44,
48,
0, 

30,
48,
0, 

5,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

1,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

15,
48,
0, 

33,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

20,
48,
0, 

32,
48,
0, 

48,
0, 

48,
0, 

3,
48,
0, 

48,
0, 

48,
0, 

16,
48,
0, 

48,
0, 

2,
48,
0, 

8,
48,
0, 

9,
48,
0, 

48,
0, 

48,
0, 

47,
0, 

48,
0, 

48,
0, 

27,
48,
0, 

48,
0, 

48,
0, 

4,
48,
0, 

48,
0, 

48,
0, 

19,
48,
0, 

10,
48,
0, 

11,
48,
0, 

12,
48,
0, 

48,
0, 

48,
0, 

25,
48,
0, 

21,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

22,
48,
0, 

48,
0, 

6,
48,
0, 

45,
48,
0, 

45,
48,
0, 

45,
48,
0, 

47,
0, 

13,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

48,
0, 

18,
48,
0, 

17,
48,
0, 

48,
0, 

48,
0, 

23,
48,
0, 

48,
0, 

48,
0, 

47,
0, 

48,
0, 

14,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

33,
48,
0, 

48,
0, 

48,
0, 

45,
48,
0, 

45,
48,
0, 

45,
48,
0, 

48,
0, 

24,
48,
0, 

26,
48,
0, 

34,
48,
0, 

48,
0, 

48,
0, 

48,
0, 

47,
0, 

48,
0, 

48,
0, 

35,
48,
0, 

45,
48,
0, 

28,
48,
0, 

29,
48,
0, 

47,
0, 

46,
0, 

46,
0, 
0};
# define YYTYPE unsigned char
struct yywork { YYTYPE verify, advance; } yycrank[] = {
0,0,	0,0,	1,3,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,4,	1,5,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	1,6,	0,0,	
55,0,	55,0,	0,0,	1,7,	
0,0,	1,8,	1,8,	1,9,	
0,0,	0,0,	1,8,	1,10,	
7,40,	1,11,	1,12,	1,12,	
1,12,	1,12,	1,12,	1,12,	
1,12,	1,12,	1,12,	55,0,	
55,0,	1,13,	1,14,	1,15,	
0,0,	0,0,	1,16,	55,0,	
55,0,	2,8,	2,8,	6,39,	
1,17,	13,48,	13,49,	14,50,	
15,51,	15,52,	2,12,	2,12,	
2,12,	2,12,	2,12,	2,12,	
2,12,	2,12,	2,12,	45,44,	
0,0,	2,13,	2,14,	2,15,	
1,8,	1,18,	1,8,	0,0,	
1,10,	0,0,	1,19,	1,20,	
0,0,	1,21,	1,22,	1,23,	
1,24,	1,25,	1,26,	24,65,	
32,85,	1,27,	1,28,	1,29,	
1,30,	1,31,	34,89,	1,32,	
1,33,	1,34,	1,35,	35,90,	
2,8,	2,18,	2,8,	12,46,	
24,66,	1,36,	2,19,	2,20,	
25,67,	2,21,	2,22,	2,23,	
2,24,	2,25,	2,26,	56,98,	
57,99,	2,27,	2,28,	2,29,	
2,30,	2,31,	3,37,	2,32,	
2,33,	2,34,	2,35,	29,78,	
26,68,	28,75,	3,0,	3,0,	
26,69,	2,36,	27,72,	12,46,	
36,91,	29,79,	27,73,	26,70,	
58,100,	26,71,	27,74,	28,76,	
30,80,	31,82,	31,83,	30,81,	
31,84,	28,77,	59,101,	60,102,	
62,104,	3,0,	3,0,	63,105,	
65,107,	66,108,	67,109,	3,0,	
68,110,	3,0,	3,0,	3,37,	
70,113,	72,114,	3,0,	3,0,	
74,117,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	69,111,	
73,115,	3,0,	3,0,	3,0,	
69,112,	73,116,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	61,44,	3,0,	64,44,	
3,0,	75,118,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,38,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
3,0,	3,0,	3,0,	3,0,	
33,86,	3,0,	9,0,	9,0,	
76,119,	77,120,	78,121,	79,122,	
81,123,	33,87,	61,103,	82,124,	
83,125,	64,106,	84,126,	33,88,	
85,127,	86,128,	87,129,	88,130,	
89,131,	90,132,	100,138,	101,139,	
102,140,	9,0,	9,0,	103,141,	
105,142,	106,143,	107,144,	9,0,	
108,145,	9,0,	9,0,	109,146,	
110,147,	111,148,	9,0,	9,0,	
112,149,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	113,150,	
115,151,	9,0,	9,0,	9,0,	
116,152,	117,125,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	118,153,	9,0,	120,156,	
9,0,	123,157,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,38,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
9,0,	9,0,	9,0,	9,0,	
124,158,	9,0,	11,41,	11,42,	
119,154,	11,43,	11,43,	11,43,	
11,43,	11,43,	11,43,	11,43,	
11,43,	11,43,	11,43,	11,44,	
126,159,	127,160,	119,155,	129,125,	
135,136,	138,167,	11,45,	11,45,	
11,45,	11,45,	11,45,	11,45,	
11,46,	11,46,	11,46,	11,46,	
11,46,	11,46,	11,46,	11,46,	
11,46,	11,46,	11,46,	11,46,	
11,46,	11,46,	11,46,	11,46,	
11,46,	11,47,	11,46,	11,46,	
139,168,	141,169,	142,125,	144,170,	
11,41,	145,171,	11,45,	11,45,	
11,45,	11,45,	11,45,	11,45,	
11,46,	11,46,	11,46,	11,46,	
11,46,	11,46,	11,46,	11,46,	
11,46,	11,46,	11,46,	11,46,	
11,46,	11,46,	11,46,	11,46,	
11,46,	11,47,	11,46,	11,46,	
16,46,	150,172,	16,45,	16,45,	
16,45,	16,45,	16,45,	16,45,	
16,45,	16,45,	16,45,	16,45,	
42,92,	42,93,	42,93,	42,93,	
42,93,	42,93,	42,93,	42,93,	
42,93,	42,93,	151,173,	17,41,	
17,46,	154,174,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
155,175,	156,176,	157,177,	159,178,	
166,165,	168,183,	16,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	169,184,	170,185,	171,186,	
172,187,	17,41,	16,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	17,46,	17,46,	17,46,	
17,46,	18,53,	173,188,	53,0,	
53,0,	176,189,	177,190,	181,182,	
183,195,	18,0,	18,0,	19,46,	
185,196,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	19,45,	
19,45,	19,45,	19,45,	186,197,	
187,198,	189,199,	53,0,	53,0,	
190,200,	195,204,	199,205,	200,206,	
18,0,	18,0,	53,0,	53,0,	
202,203,	204,209,	18,54,	205,210,	
18,0,	18,0,	18,53,	211,212,	
0,0,	18,54,	18,54,	0,0,	
18,54,	0,0,	0,0,	0,0,	
20,46,	19,46,	20,45,	20,45,	
20,45,	20,45,	20,45,	20,45,	
20,45,	20,45,	20,45,	20,45,	
0,0,	18,54,	0,0,	0,0,	
0,0,	0,0,	0,0,	18,54,	
0,0,	0,0,	0,0,	19,56,	
0,0,	0,0,	0,0,	19,57,	
0,0,	19,58,	0,0,	0,0,	
0,0,	19,46,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	20,46,	18,54,	
0,0,	0,0,	0,0,	53,55,	
0,0,	0,0,	0,0,	0,0,	
21,46,	18,55,	21,45,	21,45,	
21,45,	21,45,	21,45,	21,45,	
21,45,	21,45,	21,45,	21,45,	
0,0,	0,0,	0,0,	0,0,	
20,59,	0,0,	0,0,	0,0,	
0,0,	0,0,	20,46,	20,60,	
22,46,	0,0,	22,45,	22,45,	
22,45,	22,45,	22,45,	22,45,	
22,45,	22,45,	22,45,	22,45,	
0,0,	0,0,	0,0,	0,0,	
0,0,	23,46,	21,46,	23,45,	
23,45,	23,45,	23,45,	23,45,	
23,45,	23,45,	23,45,	23,45,	
23,45,	0,0,	93,133,	21,61,	
93,93,	93,93,	93,93,	93,93,	
93,93,	93,93,	93,93,	93,93,	
93,93,	93,93,	22,46,	0,0,	
0,0,	21,62,	0,0,	0,0,	
0,0,	0,0,	21,46,	0,0,	
0,0,	37,0,	37,0,	0,0,	
0,0,	0,0,	94,42,	23,46,	
94,94,	94,94,	94,94,	94,94,	
94,94,	94,94,	94,94,	94,94,	
94,94,	94,94,	22,63,	23,64,	
0,0,	0,0,	22,46,	0,0,	
37,0,	37,0,	0,0,	0,0,	
0,0,	0,0,	37,0,	0,0,	
37,0,	37,0,	0,0,	0,0,	
0,0,	37,0,	37,0,	23,46,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	0,0,	0,0,	
37,0,	37,0,	37,0,	0,0,	
0,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
0,0,	37,0,	0,0,	37,0,	
0,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,38,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	37,0,	
37,0,	37,0,	37,0,	43,42,	
37,0,	43,94,	43,94,	43,94,	
43,94,	43,94,	43,94,	43,94,	
43,94,	43,94,	43,94,	43,44,	
44,95,	44,95,	44,95,	44,95,	
44,95,	44,95,	44,95,	44,95,	
44,95,	44,95,	44,96,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	44,95,	44,95,	44,95,	
44,95,	44,95,	44,95,	47,97,	
47,97,	47,97,	47,97,	47,97,	
47,97,	47,97,	47,97,	47,97,	
47,97,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
47,97,	47,97,	47,97,	47,97,	
47,97,	47,97,	0,0,	54,54,	
0,0,	44,95,	44,95,	44,95,	
44,95,	44,95,	44,95,	54,0,	
54,0,	92,133,	0,0,	92,93,	
92,93,	92,93,	92,93,	92,93,	
92,93,	92,93,	92,93,	92,93,	
92,93,	0,0,	0,0,	0,0,	
47,97,	47,97,	47,97,	47,97,	
47,97,	47,97,	54,0,	54,0,	
0,0,	0,0,	0,0,	0,0,	
54,54,	0,0,	54,0,	54,0,	
54,54,	0,0,	0,0,	54,54,	
54,54,	0,0,	54,54,	0,0,	
0,0,	0,0,	0,0,	92,134,	
133,161,	133,162,	133,162,	133,162,	
133,162,	133,162,	133,162,	133,162,	
133,162,	133,162,	0,0,	54,54,	
0,0,	0,0,	0,0,	0,0,	
0,0,	54,54,	95,135,	95,135,	
95,135,	95,135,	95,135,	95,135,	
95,135,	95,135,	95,135,	95,135,	
95,136,	0,0,	0,0,	92,134,	
0,0,	0,0,	0,0,	95,135,	
95,135,	95,135,	95,135,	95,135,	
95,135,	54,54,	96,137,	96,137,	
96,137,	96,137,	96,137,	96,137,	
96,137,	96,137,	96,137,	96,137,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	96,137,	
96,137,	96,137,	96,137,	96,137,	
96,137,	0,0,	0,0,	95,135,	
95,135,	95,135,	95,135,	95,135,	
95,135,	0,0,	0,0,	0,0,	
0,0,	0,0,	97,42,	0,0,	
97,97,	97,97,	97,97,	97,97,	
97,97,	97,97,	97,97,	97,97,	
97,97,	97,97,	0,0,	96,137,	
96,137,	96,137,	96,137,	96,137,	
96,137,	97,97,	97,97,	97,97,	
97,97,	97,97,	97,97,	134,163,	
134,163,	134,163,	134,163,	134,163,	
134,163,	134,163,	134,163,	134,163,	
134,163,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
134,163,	134,163,	134,163,	134,163,	
134,163,	134,163,	0,0,	0,0,	
0,0,	97,97,	97,97,	97,97,	
97,97,	97,97,	97,97,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	136,164,	136,164,	136,164,	
136,164,	136,164,	136,164,	136,164,	
136,164,	136,164,	136,164,	136,165,	
134,163,	134,163,	134,163,	134,163,	
134,163,	134,163,	136,164,	136,164,	
136,164,	136,164,	136,164,	136,164,	
137,166,	137,166,	137,166,	137,166,	
137,166,	137,166,	137,166,	137,166,	
137,166,	137,166,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	137,166,	137,166,	137,166,	
137,166,	137,166,	137,166,	0,0,	
0,0,	0,0,	136,164,	136,164,	
136,164,	136,164,	136,164,	136,164,	
161,179,	0,0,	161,162,	161,162,	
161,162,	161,162,	161,162,	161,162,	
161,162,	161,162,	161,162,	161,162,	
0,0,	0,0,	0,0,	0,0,	
0,0,	137,166,	137,166,	137,166,	
137,166,	137,166,	137,166,	162,179,	
0,0,	162,162,	162,162,	162,162,	
162,162,	162,162,	162,162,	162,162,	
162,162,	162,162,	162,162,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	163,133,	161,180,	163,163,	
163,163,	163,163,	163,163,	163,163,	
163,163,	163,163,	163,163,	163,163,	
163,163,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
163,163,	163,163,	163,163,	163,163,	
163,163,	163,163,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	161,180,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	164,181,	164,181,	164,181,	
164,181,	164,181,	164,181,	164,181,	
164,181,	164,181,	164,181,	164,182,	
163,163,	163,163,	163,163,	163,163,	
163,163,	163,163,	164,181,	164,181,	
164,181,	164,181,	164,181,	164,181,	
165,137,	165,137,	165,137,	165,137,	
165,137,	165,137,	165,137,	165,137,	
165,137,	165,137,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	165,137,	165,137,	165,137,	
165,137,	165,137,	165,137,	0,0,	
0,0,	0,0,	164,181,	164,181,	
164,181,	164,181,	164,181,	164,181,	
179,191,	179,192,	179,192,	179,192,	
179,192,	179,192,	179,192,	179,192,	
179,192,	179,192,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	165,137,	165,137,	165,137,	
165,137,	165,137,	165,137,	180,193,	
180,193,	180,193,	180,193,	180,193,	
180,193,	180,193,	180,193,	180,193,	
180,193,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
180,193,	180,193,	180,193,	180,193,	
180,193,	180,193,	182,194,	182,194,	
182,194,	182,194,	182,194,	182,194,	
182,194,	182,194,	182,194,	182,194,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	182,194,	
182,194,	182,194,	182,194,	182,194,	
182,194,	0,0,	0,0,	0,0,	
180,193,	180,193,	180,193,	180,193,	
180,193,	180,193,	191,192,	191,192,	
191,192,	191,192,	191,192,	191,192,	
191,192,	191,192,	191,192,	191,192,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	182,194,	
182,194,	182,194,	182,194,	182,194,	
182,194,	192,192,	192,192,	192,192,	
192,192,	192,192,	192,192,	192,192,	
192,192,	192,192,	192,192,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	193,179,	191,201,	193,193,	
193,193,	193,193,	193,193,	193,193,	
193,193,	193,193,	193,193,	193,193,	
193,193,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
193,193,	193,193,	193,193,	193,193,	
193,193,	193,193,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	191,201,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	194,202,	194,202,	194,202,	
194,202,	194,202,	194,202,	194,202,	
194,202,	194,202,	194,202,	194,203,	
193,193,	193,193,	193,193,	193,193,	
193,193,	193,193,	194,202,	194,202,	
194,202,	194,202,	194,202,	194,202,	
201,207,	201,207,	201,207,	201,207,	
201,207,	201,207,	201,207,	201,207,	
201,207,	201,207,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	201,207,	201,207,	201,207,	
201,207,	201,207,	201,207,	0,0,	
0,0,	0,0,	194,202,	194,202,	
194,202,	194,202,	194,202,	194,202,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	203,208,	203,208,	
203,208,	203,208,	203,208,	203,208,	
203,208,	203,208,	203,208,	203,208,	
0,0,	201,207,	201,207,	201,207,	
201,207,	201,207,	201,207,	203,208,	
203,208,	203,208,	203,208,	203,208,	
203,208,	207,207,	207,207,	207,207,	
207,207,	207,207,	207,207,	207,207,	
207,207,	207,207,	207,207,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	207,207,	207,207,	
207,207,	207,207,	207,207,	207,207,	
0,0,	0,0,	0,0,	203,208,	
203,208,	203,208,	203,208,	203,208,	
203,208,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	208,211,	
208,211,	208,211,	208,211,	208,211,	
208,211,	208,211,	208,211,	208,211,	
208,211,	208,212,	207,207,	207,207,	
207,207,	207,207,	207,207,	207,207,	
208,211,	208,211,	208,211,	208,211,	
208,211,	208,211,	212,213,	212,213,	
212,213,	212,213,	212,213,	212,213,	
212,213,	212,213,	212,213,	212,213,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	212,213,	
212,213,	212,213,	212,213,	212,213,	
212,213,	0,0,	0,0,	0,0,	
208,211,	208,211,	208,211,	208,211,	
208,211,	208,211,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
213,214,	213,214,	213,214,	213,214,	
213,214,	213,214,	213,214,	213,214,	
213,214,	213,214,	0,0,	212,213,	
212,213,	212,213,	212,213,	212,213,	
212,213,	213,214,	213,214,	213,214,	
213,214,	213,214,	213,214,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	0,0,	0,0,	0,0,	
0,0,	213,214,	213,214,	213,214,	
213,214,	213,214,	213,214,	0,0,	
0,0};
struct yysvf yysvec[] = {
0,	0,	0,
yycrank+-1,	0,		0,	
yycrank+-29,	yysvec+1,	0,	
yycrank+-141,	0,		yyvstop+1,
yycrank+0,	0,		yyvstop+3,
yycrank+0,	0,		yyvstop+6,
yycrank+10,	0,		yyvstop+8,
yycrank+10,	0,		yyvstop+11,
yycrank+0,	0,		yyvstop+14,
yycrank+-257,	yysvec+3,	yyvstop+17,
yycrank+0,	0,		yyvstop+20,
yycrank+337,	0,		yyvstop+22,
yycrank+35,	yysvec+11,	yyvstop+25,
yycrank+13,	0,		yyvstop+28,
yycrank+14,	0,		yyvstop+31,
yycrank+15,	0,		yyvstop+34,
yycrank+414,	yysvec+11,	yyvstop+37,
yycrank+438,	0,		yyvstop+39,
yycrank+-560,	0,		yyvstop+41,
yycrank+525,	yysvec+11,	yyvstop+43,
yycrank+566,	yysvec+11,	yyvstop+45,
yycrank+618,	yysvec+11,	yyvstop+47,
yycrank+642,	yysvec+11,	yyvstop+49,
yycrank+659,	yysvec+11,	yyvstop+51,
yycrank+10,	yysvec+17,	yyvstop+53,
yycrank+17,	yysvec+17,	yyvstop+55,
yycrank+49,	yysvec+17,	yyvstop+57,
yycrank+57,	yysvec+17,	yyvstop+59,
yycrank+52,	yysvec+17,	yyvstop+61,
yycrank+46,	yysvec+17,	yyvstop+63,
yycrank+50,	yysvec+17,	yyvstop+65,
yycrank+54,	yysvec+17,	yyvstop+67,
yycrank+11,	yysvec+17,	yyvstop+69,
yycrank+165,	yysvec+17,	yyvstop+71,
yycrank+15,	yysvec+17,	yyvstop+73,
yycrank+19,	yysvec+17,	yyvstop+75,
yycrank+32,	0,		yyvstop+77,
yycrank+-732,	yysvec+3,	0,	
yycrank+0,	0,		yyvstop+80,
yycrank+0,	0,		yyvstop+82,
yycrank+0,	0,		yyvstop+84,
yycrank+0,	yysvec+17,	0,	
yycrank+424,	yysvec+17,	yyvstop+86,
yycrank+809,	yysvec+17,	yyvstop+88,
yycrank+820,	0,		0,	
yycrank+29,	yysvec+17,	yyvstop+91,
yycrank+0,	yysvec+17,	yyvstop+93,
yycrank+843,	yysvec+17,	yyvstop+95,
yycrank+0,	0,		yyvstop+97,
yycrank+0,	0,		yyvstop+99,
yycrank+0,	0,		yyvstop+101,
yycrank+0,	0,		yyvstop+103,
yycrank+0,	0,		yyvstop+105,
yycrank+-554,	yysvec+18,	yyvstop+107,
yycrank+-914,	0,		yyvstop+109,
yycrank+-27,	yysvec+54,	yyvstop+111,
yycrank+35,	yysvec+17,	yyvstop+114,
yycrank+24,	yysvec+17,	yyvstop+116,
yycrank+63,	yysvec+17,	yyvstop+118,
yycrank+59,	yysvec+17,	yyvstop+120,
yycrank+55,	yysvec+17,	yyvstop+122,
yycrank+175,	yysvec+17,	yyvstop+124,
yycrank+56,	yysvec+17,	yyvstop+126,
yycrank+71,	yysvec+17,	yyvstop+128,
yycrank+177,	yysvec+17,	yyvstop+130,
yycrank+60,	yysvec+17,	yyvstop+132,
yycrank+76,	yysvec+17,	yyvstop+134,
yycrank+63,	yysvec+17,	yyvstop+136,
yycrank+71,	yysvec+17,	yyvstop+138,
yycrank+90,	yysvec+17,	yyvstop+140,
yycrank+86,	yysv